% See SO answer: http://stackoverflow.com/questions/1966425/source-code-highlighting-in-latex#1985330

% Also useful for fixing "-shell-escape" flag issue: 
% http://tex.stackexchange.com/questions/187276/how-to-do-shell-escape-in-texworks

\chapter{ Python Magnet Arrangement \label{app:py-arrange-60} } 


\renewcommand{\theFancyVerbLine}{
  \sffamily\textcolor[rgb]{0.5,0.5,0.5}{\scriptsize\arabic{FancyVerbLine}}}



\begin{minted}[mathescape,
               linenos,
               numbersep=5pt,
               gobble=2,
	    label=\fbox{\detokenize{pk-1-same-test.py}},
	    labelposition=topline,
               frame=lines,
               framesep=2mm]{python}
  # -*- coding: utf-8 -*-
  """
  Created on Mon Feb  6 16:38:00 2017
  
  @author: Ruvim
  """
  
  import os, sys; 
  
  sys.path.append (os.path.abspath (".")); 
  import ring_optimize as ro; 
  
  import numpy; 
  
  # Prepare the parameters for ring optimization: 
  cell_params = ro.CellParameters (B_max = 60); # Water cell parameters. 
  optimize_params = ro.OptimizationParameters (); 
  # Optionally, we can also customize these before passing them 
  # to RingOptimizeContext (); 
  
  # For example, set the number of magnets for each ring: 
  cell_params.M_num = numpy.loadtxt ("pk-1-magnet-counts.txt", dtype = int); 
  
  
  # Create a ring optimize context: 
  optimize = ro.RingOptimizeContext (cell_params, optimize_params); 
  
  # Optimize!: 
  result = optimize.find_profile (); 
  state = result.x; 
  
  # Save the result: 
  numpy.savetxt ("pk-1-same-test.txt", state); 
  
  
\end{minted}







\begin{minted}[mathescape,
               linenos,
               numbersep=5pt,
               gobble=2,
	    label=\fbox{\detokenize{pk-1b-plot.py}},
	    labelposition=topline,
               frame=lines,
               framesep=2mm]{python}
  # -*- coding: utf-8 -*-
  """
  Created on Mon Feb  6 17:56:19 2017
  
  @author: Ruvim
  """
  
  import os, sys; 
  
  sys.path.append (os.path.abspath (".")); 
  import ring_optimize as ro; 
  
  import numpy; 
  
  # Prepare the parameters for ring optimization: 
  cell_params = ro.CellParameters (B_max = 60); # Water cell parameters. 
  optimize_params = ro.OptimizationParameters (); 
  # Set the number of magnets for each ring: 
  cell_params.M_num = numpy.loadtxt ("pk-1-magnet-counts.txt", dtype = int); 
  
  # Create a result plotter instance: 
  optimize = ro.RingOptimizeContext (cell_params, optimize_params); 
  plot_params = ro.PlotParameters (); 
  plot_params.readCellParameters (cell_params); 
  plotter = ro.RingResultPlotter (optimize, plot_params); 
  
  # Read the result of last time's optimization: 
  state = numpy.loadtxt ("pk-1-same-test.txt"); 
  
  
  # Plot!: 
  plotter.plot3 (state); 
  plotter.plot4 (state); 
  
  
\end{minted}















\begin{minted}[mathescape,
               linenos,
               numbersep=5pt,
               gobble=2,
	    label=\fbox{ring\_optimize.py},
	    labelposition=topline,
               frame=lines,
               framesep=2mm]{python}
  # -*- coding: utf-8 -*-
  """
  Created on Mon Feb  6 14:41:03 2017
  
  @author: Ruvim
  """
  
  import numpy; 
  import scipy.optimize; 
  import matplotlib.pyplot as pp; 
  import matplotlib.patches as patches; # See http://matthiaseisen.com/pp/patterns/p0203/ 
  
  
  
  # Fit from KJ Magnetics N42-14-14 B Strength.py, from folder Field-Strength: 
  M = 217209.80135205924; # for mm, valid from r = 0.4 in 
  
  # Typical magnet radius and height for our N42 .25-by-.25-inch magnets: 
  magnet_radius = 3.3; # mm 
  magnet_height = 6.3; # mm 
  
  
  def profile_Keplerian (r, optimize_context): 
  	B_max = optimize_context.cell_params.B_max; 
  	at_minR = optimize_context.cell_params.r_min ** (-3/2); 
  	B_factor = B_max / at_minR; 
  	result = B_factor * r ** (-3/2); 
  	result[numpy.isnan (result) + numpy.isinf (result)] = 0; 
  	return result; 
  
  
  def chord_length (R = 1, r = 1, d = 1): 
  	return (1 / d) * numpy.sqrt (4 * d * d * R * R - (d * d - r * r + R * R) ** 2); 
  
  
  
  # CellParameters 
  # 
  # A class to hold the water cell parameters and limitations. 
  # Parameters include the inner and outer radii of 
  # the donut containing the water area, 
  # the magnetic field strength factor (B_factor), 
  # the minimum/maximum radii of placement of a magnet ring, 
  # the minimum/maximum heights the rings can be lowered/raised to, 
  # and the number of magnets in each magnet ring. 
  # 
  
  class CellParameters: 
  	M_num = [2]; 
  	r_min = 30; 
  	r_max = 100; 
  	B_max = 200; 
  	# Magnet grid construction parameters: 
  	# 1. Maximum and minimum magnet heights (below the water) we can allow: 
  	m_height_min = 10; 
  	m_height_max = 240; 
  	# 2. Maximum and minimum magnet ring radii we can allow: 
  	m_constrain_min = 10; # From how much we can fit ... 
  	m_constrain_max = 120; # Up to what we can build using the 3D printer. 
  	# 3. The range of radii to initialize the ring arrangement with (has 
  	#     little to do with the final arrangement, really): 
  	m_min = 30; 
  	m_max = 200; 
  	m_min_sep = 3; 
  	# ... 
  	def __init__ (our, B_max = 200, r_min = 30, r_max = 90): 
  		our.B_max = B_max; 
  		our.r_min = r_min; 
  		our.r_max = r_max; 
  
  
  # ProbeParameters 
  # 
  # The base-class for holding parameters on where 
  # and how to probe the magnetic field. 
  # 
  
  class ProbeParameters: 
  	p_cnt = 15; 
  	p_min = -1; 
  	p_max = +1; 
  	probe_xs = []; 
  	probe_ys = []; 
  	probe_dx = 0; 
  	probe_dy = 0; 
  	probe_mesh_coord_x = []; 
  	probe_mesh_coord_y = []; 
  	probe_lenX = 0; 
  	probe_lenY = 0; 
  	donut_minR = 0; 
  	donut_maxR = 0; 
  	def readCellParameters (our, cell_parameters): 
  		our.setBounds (cell_parameters.r_min, cell_parameters.r_max); 
  	def setBounds (our, r_min, r_max): 
  		our.p_min = -r_max; 
  		our.p_max = +r_max; 
  		our.donut_minR = r_min; 
  		our.donut_maxR = r_max; 
  		our.calcProbes (); 
  	def calcProbes (our): 
  		# Construct the B-field probes: 
  		our.probe_xs = numpy.linspace (our.p_min, our.p_max, our.p_cnt); 
  		our.probe_ys = numpy.linspace (our.p_min, our.p_max, our.p_cnt); 
  		our.probe_dx = our.probe_xs[1] - our.probe_xs[0]; 
  		our.probe_dy = our.probe_ys[1] - our.probe_ys[0]; 
  		# mesh_coord is for using the pcolormesh () from pyplot ... 
  		our.probe_mesh_coord_x = numpy.append (our.probe_xs - our.probe_dx / 2, our.probe_xs[-1] + our.probe_dx / 2); 
  		our.probe_mesh_coord_y = numpy.append (our.probe_ys - our.probe_dy / 2, our.probe_ys[-1] + our.probe_dy / 2); 
  		our.probe_lenX = len (our.probe_xs); 
  		our.probe_lenY = len (our.probe_ys); 
  
  
  # OptimizationParameters 
  # 
  # A class to hold parameters such as where to 
  # start or stop probing the magnetic field for 
  # optimization. 
  # 
  
  class OptimizationParameters (ProbeParameters): 
  	def __init__ (our): 
  		our.p_cnt = 15; 
  
  
  # PlotParameters 
  # 
  # A class to describe what and how to plot. 
  # 
  
  class PlotParameters (ProbeParameters): 
  	r_cnt = 131; 
  	slice_rs = []; 
  	avl_colors = numpy.array (['b', 'g', 'r', 'c', 'm', 'y', 'k', \
  		'b', 'g', 'r', 'c', 'm', 'y', 'k']); 
  	def __init__ (our): 
  		our.p_cnt = 81; # More points for showing. 
  	def setBounds (our, r_min, r_max): 
  		super (PlotParameters, our).setBounds (r_min, r_max); 
  		our.slice_rs = numpy.linspace (r_min, r_max, our.r_cnt); 
  
  
  # RingContext 
  # 
  # A class to describe a cell system's setup with rings. 
  # The only things this context does not describe is 
  # the actual water cell's limitations or dimensions, 
  # optimization parameters, and optimization results 
  # (i.e., the "state" vector). 
  # 
  
  class RingContext: 
  	# State initial values: 
  	magnet_ring_radii = []; 
  	zero_delta_angles = []; 
  	h0 = []; 
  	# Rows and columns, for the grid size: 
  	M_rows = 0; 
  	M_cols = 0; 
  	# Multidimensional grids for use everywhere in the code: 
  	I_use = []; 
  	R_use = []; 
  	M_use = []; 
  	A_use = []; 
  	# A copy of M_num in numpy array format: 
  	n_magnets_per_ring = []; 
  	# Methods: 
  	def make_h0 (our, height = 1e1): 
  		return height * numpy.ones_like (our.magnet_ring_radii); 
  	def init_radii (our, m_min, m_max, count = 0): 
  		m_count = count; 
  		if (m_count == 0): 
  			m_count = len (our.magnet_ring_radii); 
  		# Linearly initialize the magnet ring radii: 
  		our.magnet_ring_radii = \
  			numpy.linspace (m_min, m_max, m_count); 
  	def init_grids (our, M_num): 
  		# Initialize magnet ring radii: 
  		our.init_radii (0, 1, len (M_num)); 
  		# Make an array of 0s: 
  		our.zero_delta_angles = numpy.zeros_like (our.magnet_ring_radii); 
  		# Fill out some heights: 
  		our.h0 = our.make_h0 (); 
  		# Turn the magnet counts per ring into a numpy array: 
  		n_magnets_per_ring = numpy.array (M_num); 
  		our.n_magnets_per_ring = n_magnets_per_ring; 
  		# Find the maximum number per ring, and use that as a grid dimension: 
  		n_magnets_max_per_ring = n_magnets_per_ring.max (); 
  		# Initialize some 2D grids: 
  		our.M_rows = M_rows = len (M_num); 
  		our.M_cols = M_cols = n_magnets_max_per_ring; 
  		I_grid = numpy.zeros ((M_rows, M_cols)); # Just a grid of 1s and 0s for whether there is a magnet or not. 
  		R_grid = numpy.zeros ((M_rows, M_cols), dtype = int); # A "row number" grid of row numbers. 
  		A_grid = numpy.zeros ((M_rows, M_cols)); # Rotation angles. 
  		M_grid = numpy.zeros ((M_rows, M_cols)); # Magnetization grid. 
  		for ring in range (0, len (M_num)): 
  			I_grid[ring, 0 : n_magnets_per_ring[ring]] = 1; 
  			R_grid[ring, 0 : n_magnets_per_ring[ring]] = ring; 
  			M_grid[ring, 0 : n_magnets_per_ring[ring]] = M; 
  			A_grid[ring, 0 : n_magnets_per_ring[ring]] = numpy.linspace (0, 2 * numpy.pi, n_magnets_per_ring[ring], endpoint = False); 
  		# Use this 'for' loop only once, and then all the rest is 
  		# numpy numerical processing using grids (no more loops!). 
  		# In order to be able to use the powerful numerical processing 
  		# of numpy, we have to reshape things into multiple dimensions: 
  		our.I_use = I_grid.reshape ((1, 1, M_rows, M_cols)); 
  		our.R_use = R_grid.reshape ((1, 1, M_rows, M_cols)); 
  		our.M_use = M_grid.reshape ((1, 1, M_rows, M_cols)); 
  		our.A_use = A_grid.reshape ((1, 1, M_rows, M_cols)); 
  		# Axes: (probe X, probe Y, which ring, which magnet) 
  	# State: 
  	def get_hs (our, state): 
  		return state[0: len (our.h0)]; 
  	def get_rs (our, state): 
  		return state[len (our.h0) : len (our.h0) + len (our.magnet_ring_radii)]; 
  	def get_da (our, state): 
  		base_index = len (our.h0) + len (our.magnet_ring_radii); 
  		return state[base_index : base_index + len (our.zero_delta_angles)]; 
  	def make_state (our, hs, rs, dA): 
  		state = numpy.zeros ((len (our.h0) + \
  			len (our.magnet_ring_radii) +\
  			len (our.zero_delta_angles),)); 
  		state[0 : len (our.h0)] = hs[0 : len (our.h0)]; 
  		state[len (our.h0) : len (our.h0) + len (our.magnet_ring_radii)] = \
  			rs[0 : len (our.magnet_ring_radii)]; 
  		state[len (our.h0) + len (our.magnet_ring_radii) : \
  			len (our.h0) + len (our.magnet_ring_radii) + \
  			len (our.zero_delta_angles)] = \
  			dA[0 : len (our.zero_delta_angles)]; 
  		return state; 
  	# Generation of the x, y, z, and r parameters for the dipole B-field equations: 
  	def get_x (our, state, A, xs, ys): 
  		rs = our.get_rs (state); 
  		dA_linear = our.get_da (state); 
  		dA = dA_linear.reshape ((1, 1, len (dA_linear), 1)); 
  		angle = -(A + dA); 
  		x = xs.reshape (len (xs), 1, 1, 1); 
  		y = ys.reshape (1, len (ys), 1, 1); 
  		cosA = numpy.cos (angle); 
  		sinA = numpy.sin (angle); 
  		xp = cosA * x - sinA * y; 
  		return xp - rs.reshape (1, 1, len (rs), 1); 
  	def get_y (our, state, A, xs, ys): 
  		dA_linear = our.get_da (state); 
  		dA = dA_linear.reshape ((1, 1, len (dA_linear), 1)); 
  		angle = -(A + dA); 
  		x = xs.reshape (len (xs), 1, 1, 1); 
  		y = ys.reshape (1, len (ys), 1, 1); 
  		cosA = numpy.cos (angle); 
  		sinA = numpy.sin (angle); 
  		yp = sinA * x + cosA * y; 
  		return yp; 
  	def get_z (our, state, A, xs, ys): 
  		hs = our.get_hs (state); 
  		return hs.reshape (1, 1, len (hs), 1); 
  
  
  # RingOptimizeContext 
  # 
  # A class to hold variables and parameters while 
  # the optimization code does its minimizing. 
  # 
  
  class RingOptimizeContext (RingContext): 
  	cell_params = {}; 
  	optimize_params = {}; 
  	desired_strength = (profile_Keplerian,); 
  	min_rs = []; 
  	last_result = []; 
  	def __init__ (our, cell_parameters, optimize_parameters): 
  		optimize_parameters.readCellParameters (cell_parameters); 
  		our.cell_params = cell_parameters; 
  		our.optimize_params = optimize_parameters; 
  		our.init_grids (our.cell_params.M_num); 
  		return; 
  	def calc_min_rs (our): 
  		S = chord_length (R = our.cell_params.r_min, r = magnet_radius, d = our.cell_params.r_min); 
  		dR = S + our.cell_params.m_min_sep; 
  		min_circ = numpy.maximum (our.n_magnets_per_ring * dR, our.cell_params.r_min); 
  		our.min_rs = min_circ / (2 * numpy.pi); 
  		return; 
  	def find_profile (our, desired_strength = profile_Keplerian): 
  		our.init_radii (our.cell_params.r_min, our.cell_params.r_max); 
  		our.desired_strength = (desired_strength,); 
  		our.calc_min_rs (); 
  		b_hs = tuple ((our.cell_params.m_height_min, our.cell_params.m_height_max) for i in range (0, len (our.h0))); 
  		b_rs = tuple ((our.min_rs[i], our.cell_params.m_constrain_max) for i in range (0, len (our.magnet_ring_radii))); 
  		b_as = tuple ((0, numpy.pi) for i in range (0, len (our.zero_delta_angles))); 
  		b = b_hs + b_rs + b_as; 
  		our.last_result = scipy.optimize.minimize (to_minimize_inZ, \
  					our.make_state (our.h0, our.magnet_ring_radii, our.zero_delta_angles), \
  					(our, MagneticFieldCalculation (our)), \
  			bounds = b); 
  		return our.last_result; 
  
  
  class RingResultPlotter: 
  	plot_params = {}; 
  	optimize_context = {}; 
  	b_calc = {}; 
  	def __init__ (our, optimize_context, plot_params): 
  		our.optimize_context = optimize_context; 
  		our.plot_params = plot_params; 
  		our.b_calc = MagneticFieldCalculation (optimize_context); 
  	def plot3 (our, state): 
  		our.plot3a (state); 
  		our.plot3b (state); 
  		our.plot3c (state); 
  	def plot4 (our, state): 
  		our.plot4a (state); 
  		our.plot4b (state); 
  	def plot3a (our, state, save_as = "desired-color-mesh.png"): 
  		ppar = our.plot_params; 
  		octx = our.optimize_context; 
  		pp.figure (figsize = (4, 4)); 
  		pp.title ("Desired Profile"); 
  		pp.xlabel ("Measurement Position X (mm)"); 
  		pp.ylabel ("Measurement Position Y (mm)"); 
  		pp.xlim (ppar.p_min, ppar.p_max); 
  		pp.ylim (ppar.p_min, ppar.p_max); 
  		grid_r = get_r_2d (ppar.probe_xs, ppar.probe_ys); 
  		fxn = octx.desired_strength[0]; 
  		desired_grid = fxn (grid_r, octx); 
  		desired_grid[grid_r < ppar.donut_minR] = 0; 
  		desired_grid[grid_r > ppar.donut_maxR] = 0; 
  		pp.pcolormesh (ppar.probe_mesh_coord_x, ppar.probe_mesh_coord_y, desired_grid, label = "Desired Profile"); 
  		pp.savefig (save_as); 
  	def plot3b (our, state, save_as = "actual-color-mesh.png"): 
  		ppar = our.plot_params; 
  		octx = our.optimize_context; 
  		Bz = our.b_calc.net_field_z (state, ppar.probe_xs, ppar.probe_ys); 
  		pp.figure (figsize = (4, 4)); 
  		pp.title ("Actual Theoretical"); 
  		pp.xlabel ("Measurement Position X (mm)"); 
  		pp.ylabel ("Measurement Position Y (mm)"); 
  		pp.xlim (ppar.p_min, ppar.p_max); 
  		pp.ylim (ppar.p_min, ppar.p_max); 
  		grid_r = get_r_2d (ppar.probe_xs, ppar.probe_ys); 
  		Bz[grid_r < ppar.donut_minR] = 0; 
  		Bz[grid_r > ppar.donut_maxR] = 0; 
  		pp.pcolormesh (ppar.probe_mesh_coord_x, ppar.probe_mesh_coord_y, Bz); 
  		pp.savefig (save_as); 
  	def plot3c (our, state, save_as = "desired-vs-field-slice.png"): 
  		ppar = our.plot_params; 
  		octx = our.optimize_context; 
  		Bz = our.b_calc.net_field_z (state, ppar.slice_rs, ppar.probe_ys); 
  		Bz_slice = Bz[:, ppar.probe_ys == 0]; 
  		pp.figure (); 
  		pp.title ("Desired vs Actual Field"); 
  		pp.xlabel ("Radial Position (mm)"); 
  		pp.ylabel ("Field Strength (gauss)"); 
  		pp.xlim (ppar.slice_rs.min (), ppar.slice_rs.max ()); 
  		fxn = octx.desired_strength[0]; 
  		pp.plot (ppar.slice_rs, fxn (get_r_2d (ppar.slice_rs, numpy.array ([0])), octx), label = "Desired"); 
  		pp.plot (ppar.slice_rs, Bz_slice, label = "Actual"); 
  		pp.legend (loc = "best"); 
  		pp.savefig (save_as); 
  	# This function draws circles where all the magnets will go: 
  	def plot4a (our, state, save_as = "2d-magnet-arrangement.png"): 
  		ppar = our.plot_params; 
  		octx = our.optimize_context; 
  		rs = octx.get_rs (state); 
  		dA = octx.get_da (state); 
  		mask = octx.M_use != 0; # mask tells us True if there is a magnet there 
  		a = (octx.A_use + dA.reshape ((1, 1, len (dA), 1)))[mask]; 
  		r = (octx.I_use * rs.reshape ((1, 1, len (rs), 1)))[mask]; 
  		x = r * numpy.cos (a); 
  		y = r * numpy.sin (a); 
  		s = magnet_radius * 4; # Convert to pt? 
  		pp.figure (figsize = (6,6)); 
  		pp.title ("Magnet Arrangement"); 
  		pp.xlabel ("Position X (mm)"); 
  		pp.ylabel ("Position Y (mm)"); 
  		pp.scatter (x, y, s, ppar.avl_colors[octx.R_use[mask]]); 
  		pp.savefig (save_as); 
  	# This function draws circles of how high each magnet ring is: 
  	def plot4b (our, state, save_as = "ring-heights.png"): 
  		ppar = our.plot_params; 
  		octx = our.optimize_context; 
  		hs = octx.get_hs (state); 
  		rs = octx.get_rs (state); 
  		fig = pp.figure (); 
  		pp.title ("Magnet Ring Heights"); 
  		h_max = hs.max (); 
  		ax1 = fig.add_subplot (111, aspect='equal'); 
  		
  		for i in range (0, min (len (rs), len (hs))): 
  			# Adapted from http://matthiaseisen.com/pp/patterns/p0203/ code: 
  			ax1.add_patch ( 
  			    patches.Rectangle ( 
  			        (rs[i] - magnet_radius, 2 * h_max - hs[i] - magnet_height / 2),   # (x,y)
  			        2 * magnet_radius,          # width
  			        magnet_height,          # height
  			    ) 
  			); 
  		pp.plot (rs, 2 * hs.max () - hs, 'ro', label = "Ring Heights"); 
  		fig.savefig (save_as); 
  
  
  # MagneticFieldCalculation 
  # 
  # A class for doing the actual magnetic field calculations. 
  # Used by the optimization functions in this module. 
  # 
  
  class MagneticFieldCalculation: 
  	context = {}; 
  	def __init__ (our, b_calc_context): 
  		our.context = b_calc_context; 
  	# The functions that return the B-field grids in the correct array shapes (the returned arrays are "in shape"): 
  	def inshape_fieldX (our, state, xs, ys): 
  		return B_x (our.context.M_use, our.context.get_x (state, our.context.A_use, xs, ys), our.context.get_y (state, our.context.A_use, xs, ys), our.context.get_z (state, our.context.A_use, xs, ys)); 
  	def inshape_fieldY (our, state, xs, ys): 
  		return B_y (our.context.M_use, our.context.get_x (state, our.context.A_use, xs, ys), our.context.get_y (state, our.context.A_use, xs, ys), our.context.get_z (state, our.context.A_use, xs, ys)); 
  	def inshape_fieldZ (our, state, xs, ys): 
  		return B_z (our.context.M_use, our.context.get_x (state, our.context.A_use, xs, ys), our.context.get_y (state, our.context.A_use, xs, ys), our.context.get_z (state, our.context.A_use, xs, ys)); 
  	
  	# This function returns a grid of the net X,Y,Z magnetic field: 
  	def net_field_xyz (our, state, xs, ys): 
  		x = our.context.get_x (state, our.context.A_use, xs, ys); 
  		y = our.context.get_y (state, our.context.A_use, xs, ys); 
  		z = our.context.get_z (state, our.context.A_use, xs, ys); 
  		# Sum due to each magnet in the ring (axis 3), 
  		# and due to each ring (axis 2): 
  		netX = B_x (our.context.M_use, x, y, z).sum (axis = 3).sum (axis = 2); 
  		netY = B_y (our.context.M_use, x, y, z).sum (axis = 3).sum (axis = 2); 
  		netZ = B_z (our.context.M_use, x, y, z).sum (axis = 3).sum (axis = 2); 
  		return numpy.array ([netX, netY, netZ]); 
  	
  	# These functions return just a 2D grid of the magnetic field: 
  	def net_field_x (our, state, xs, ys): 
  		return our.inshape_fieldX (state, xs, ys).sum (axis = 3).sum (axis = 2); 
  	def net_field_y (our, state, xs, ys): 
  		return our.inshape_fieldY (state, xs, ys).sum (axis = 3).sum (axis = 2); 
  	def net_field_z (our, state, xs, ys): 
  		return our.inshape_fieldZ (state, xs, ys).sum (axis = 3).sum (axis = 2); 
  	def net_field_abs (our, state, xs, ys): 
  		return numpy.sqrt ((our.net_field_xyz (state, xs, ys) ** 2).sum (axis = 0)); 
  
  
  
  
  
  # B-field measurement for a magnetic dipole of magnetization M: 
  def B_x (M, x, y, z): 
  	r = xyz_to_r (x, y, z); 
  	return 3 * M * x * z / r ** 5; # B_x 
  def B_y (M, x, y, z): 
  	r = xyz_to_r (x, y, z); 
  	return 3 * M * y * z / r ** 5; # B_y 
  def B_z (M, x, y, z): 
  	r = xyz_to_r (x, y, z); 
  	return M * (3 * z ** 2 - r ** 2) / r ** 5; # B_z 
  
  
  
  
  
  
  # Miscellaneous functions: 
  
  def xyz_to_r (x, y, z): 
  	return numpy.sqrt (x * x + y * y + z * z); 
  
  def get_r_2d (x, y): 
  	return numpy.sqrt (x.reshape ((len (x), 1)) ** 2 + y.reshape ((1, len (y))) ** 2); 
  
  def norm (x): 
  	return numpy.sqrt (numpy.sum (x * x)); 
  
  def to_scalar (x): 
  	return norm (x); 
  
  
  
  # Functions for doing the actual minimization cost function evaluations: 
  
  def grid_to_minimize_z (state, optimize_context, b_field_context): 
  	opp = optimize_context.optimize_params; 
  	desired = optimize_context.desired_strength[0] (get_r_2d (opp.probe_xs, opp.probe_ys), optimize_context); 
  	actual = b_field_context.net_field_z (state, opp.probe_xs, opp.probe_ys); 
  	grid =  desired - actual; 
  	r = get_r_2d (opp.probe_xs, opp.probe_ys); 
  	grid[r < opp.donut_minR] = 0; 
  	grid[r > opp.donut_maxR] = 0; 
  	return grid; 
  
  def to_minimize_inZ (state, optimize_context, b_field_context): 
  	return to_scalar (grid_to_minimize_z (state, optimize_context, b_field_context)); 
  
  def grid_to_minimize_abs (state, optimize_context, b_field_context): 
  	opp = optimize_context.optimize_params; 
  	grid = optimize_context.desired_strength[0] (get_r_2d (opp.probe_xs, opp.probe_ys), optimize_context) - \
  			b_field_context.net_field_abs (state, opp.probe_xs, opp.probe_ys); 
  	r = get_r_2d (opp.probe_xs, opp.probe_ys); 
  	grid[r < opp.donut_minR] = 0; 
  	grid[r > opp.donut_maxR] = 0; 
  	return grid; 
  
  def to_minimize_inAbs (state, optimize_context, b_field_context): 
  	return to_scalar (grid_to_minimize_abs (state, optimize_context, b_field_context)); 
  
  
  
  
  
  
  
\end{minted}
